#INCLUDE "dcdialog.CH"

#define FONTBOLD      "Bold"    // change to "Fett" for German versions
#define FONTITALIC    "Italic"  // change to "Kursiv" for German versions
#define CRLF          Chr(13)+Chr(10)
#define GENDER_MALE   'agent.ico'
#define GENDER_FEMALE 'she_user.ico'
#define GOOD_VALUE    'online.ico'
#define BAD_VALUE     'offline.ico'

#pragma library("dclipx.lib")
#pragma library("dclip1.lib") // for DC_LoadRdds()

FUNCTION Main()

LOCAL GetList := {}, GetOptions := {}, oBrowse, nResDll, ;
   aPres := ;
         { { XBP_PP_COL_DA_ROWHEIGHT, 50 }, ;  // rows are 50 pixels high
           { XBP_PP_COL_DA_CELLHEIGHT, 50 } ,;
           { XBP_PP_COL_DA_HILITE_BGCLR, GRA_CLR_PALEGRAY },;   // Hilite BG color
           { XBP_PP_COL_DA_CELLFRAMELAYOUT, XBPFRAME_BOX } ,;
           { XBP_PP_COL_DA_FRAMELAYOUT,     XBPFRAME_NONE} ,;
           { XBP_PP_COL_DA_ROWSEPARATOR, XBPCOL_SEP_LINE },  /* Row Sep  */     ;
           { XBP_PP_COL_DA_COLSEPARATOR, XBPCOL_SEP_LINE } },  /* Col Sep  */     ;
   lOwnerDraw := .F.

DCGETOPTIONS AUTORESIZE

DC_LoadRdds()

nResDll := DllLoad('DCRES.DLL') /// load eXpress++ custom bitmaps
DC_BitmapResourceFile( { nResDll } )
DC_BitmapTransparentColor({192,192,192})

DC_BrowseColor( { nil, GRA_CLR_WHITE, nil, GraMakeRGBColor( {214,243,244} ) } )

USE customer VIA 'FOXCDX'

@ 0,0 DCBROWSE oBrowse ALIAS 'CUSTOMER' SIZE 96,25 PRESENTATION aPres FIT ;
      SUBCLASS 'XbpOwnerDrawBrowseGeneric()' USEVISUALSTYLE NOHSCROLL ;
      PREEVAL {|o|o:stdFontCompoundName := '10.Tahoma', ;
                  o:boldFontCompoundName := '10.Tahoma '+FONTBOLD, ;
                  o:boldItalicFontCompoundName := '12.Tahoma '+FONTBOLD+' '+FONTITALIC}

DCBROWSECOL DATA {||CellArray(1)} ;
                    HEADER {{'ID'}} WIDTH 5 PARENT oBrowse ;
                    OWNERDRAW

DCBROWSECOL DATA {||CellArray(2)} ;
                    HEADER 'Name/Address'  WIDTH 25 PARENT oBrowse ;
                    COLOR {||{IF('Software'$CUSTOMER->bill_name,GraMakeRGBColor( { 253, 120, 41 } ),GRA_CLR_DARKGREEN),oBrowse:rowColor()[2]}} ;
                    OWNERDRAW

DCBROWSECOL DATA {||CellArray(3)} ;
                    HEADER 'Contact'  WIDTH 15 PARENT oBrowse ;
                    COLOR {||{GRA_CLR_DARKRED,oBrowse:rowColor()[2]}} ;
                    OWNERDRAW

DCBROWSECOL DATA {||CellArray(4)} ;
                    HEADER 'Info/Rating' WIDTH 10 PARENT oBrowse ;
                    COLOR {||{GRA_CLR_DARKBLUE,GRA_CLR_YELLOW}} ;
                    OWNERDRAW

DCBROWSECOL DATA {||CellArray(5)} ;
                    HEADER 'Bitmap' ;
                    WIDTH 6 PARENT oBrowse ;
                    OWNERDRAW

DCBROWSECOL FIELD CUSTOMER->phone  HEADER 'Phone' WIDTH  10 PARENT oBrowse

@ 26,0 DCCHECKBOX lOwnerDraw PROMPT 'Use ownerdrawing' ;
       ACTION {||oBrowse:lOwnerDraw := lOwnerDraw,oBrowse:InvalidateRect()}

DCREAD GUI FIT TITLE 'Ownerdrawing sample' OPTIONS GetOptions

CLOSE ALL
RETURN nil

* ----------

STATIC FUNCTION CellArray( nWhich )

LOCAL aCell, i

/*
  [1] = <ocData>
  [2] = <nCol>
  [3] = <nRow>
  [4] = <nWidth>
  [5] = <nHeight>
  [6] = <font>
  [7] = <selectedFont>
  [8] = <fgColor>
 [ 9] = <bgColor>
 [10] = <nAlign>
*/

IF nWhich == 1
  aCell := { {CUSTOMER->cust_nmbr,,,,,'10.Tahoma Bold','12.Tahoma Bold Italic'} }

ELSEIF nWhich == 2
  aCell := { {CUSTOMER->bill_name,,,,,'10.Tahoma Bold','12.Tahoma Bold Italic'}, ;
             {CUSTOMER->bill_strt}, ;
             {Trim(CUSTOMER->bill_city)+' '+ CUSTOMER->bill_zip} }

ELSEIF nWhich == 3
  aCell := { {CUSTOMER->contact,,,,,'10.Tahoma Bold','12.Tahoma Bold Italic'}, ;
             {CUSTOMER->email}, ;
             {IF(CUSTOMER->cont_gend=='m',GENDER_MALE,GENDER_FEMALE),5,45} }

ELSEIF nWhich == 4
  aCell := { {CustInfo(CUSTOMER->cust_val),,,,,'10.Tahoma Bold'} }
  IF CUSTOMER->cust_val == 0
    AAdd(aCell,{BAD_VALUE,5,35,10,10})
  ELSE
    FOR i := 1 TO CUSTOMER->cust_val
      AAdd(aCell,{GOOD_VALUE,((i-1)*12)+5,35,10,10})
    NEXT
  ENDIF

ELSEIF nWhich == 5
  aCell := { { 7300 + CUSTOMER->(RecNo()), 5,45,35,35 } }

ENDIF

RETURN aCell

* ---------

STATIC FUNCTION CustInfo(nValue)
DO CASE
  CASE nValue == 0
  RETURN 'bad'
  CASE nValue == 1
  RETURN 'ok'
  CASE nValue == 2
  RETURN 'good'
  CASE nValue == 3
  RETURN 'very good'
  CASE nValue == 4
  RETURN 'excellent'
  CASE nValue == 5
  RETURN 'best ever'
ENDCASE
RETURN 'not known'

PROC appsys ; RETURN


