#INCLUDE "dcdialog.CH"
#INCLUDE "appevent.CH"

#define FONTBOLD      "Bold"    // change to "Fett" for German versions
#define FONTITALIC    "Italic"  // change to "Kursiv" for German versions
#define CRLF          Chr(13)+Chr(10)

#pragma library("dclipx.lib")
#pragma library("dclip1.lib") // for DC_LoadRdds()

FUNCTION Main()

LOCAL GetList[0], GetOptions, aCalendar[300,7], lOwnerDraw := .t., ;
      oBrowse, aPres, nRow

aPres := ;
      { { XBP_PP_COL_DA_ROWHEIGHT, 140 }, ;  // rows are 48 pixels high
        { XBP_PP_COL_DA_CELLHEIGHT, 140 } ,;
        { XBP_PP_COL_DA_HILITE_BGCLR, GraMakeRGBColor({204,255,191}) },;   // Hilite BG color
        { XBP_PP_COL_DA_ROWSEPARATOR, XBPCOL_SEP_LINE },   /* Row Sep  */     ;
        { XBP_PP_COL_DA_COLSEPARATOR, XBPCOL_SEP_LINE } }  /* Col Sep  */     ;

DC_LoadRdds()

USE calendar VIA 'FOXCDX' INDEX calendar
CALENDAR->(OrdSetFocus('DATE'))

nRow := LoadCalendarArray(aCalendar)

@ 0,0 DCBROWSE oBrowse DATA aCalendar SIZE 96,37 PRESENTATION aPres FIT ;
      SUBCLASS 'XbpOwnerDrawBrowseGeneric()' USEVISUALSTYLE ;
      RESIZE DCGUI_RESIZE_RESIZEONLY ;
      RESIZECOLUMNS ;
      PREEVAL {|o|o:lOwnerDraw := lOwnerDraw, ;
                  o:stdFontCompoundName := '10.Tahoma', ;
                  o:boldFontCompoundName := '10.Tahoma '+FONTBOLD, ;
                  o:boldItalicFontCompoundName := '12.Tahoma '+FONTBOLD+' '+FONTITALIC} ;
      ITEMSELECTED {||EditCell(oBrowse)}

DCBROWSECOL DATA {||CellArray(1,oBrowse,.f.)} ;
                    HEADER 'Sunday' WIDTH 15 PARENT oBrowse ;
                    OWNERDRAW ;
                    COLOR {||CellArray(1,oBrowse,.t.)}

DCBROWSECOL DATA {||CellArray(2,oBrowse,.f.)} ;
                    HEADER 'Monday' WIDTH 15 PARENT oBrowse ;
                    OWNERDRAW ;
                    COLOR {||CellArray(2,oBrowse,.t.)}

DCBROWSECOL DATA {||CellArray(3,oBrowse,.f.)} ;
                    HEADER 'Tuesday' WIDTH 15 PARENT oBrowse ;
                    OWNERDRAW ;
                    COLOR {||CellArray(3,oBrowse,.t.)}

DCBROWSECOL DATA {||CellArray(4,oBrowse,.f.)} ;
                    HEADER 'Wednesday' WIDTH 15 PARENT oBrowse ;
                    OWNERDRAW ;
                    COLOR {||CellArray(4,oBrowse,.t.)}

DCBROWSECOL DATA {||CellArray(5,oBrowse,.f.)} ;
                    HEADER 'Thursday' WIDTH 15 PARENT oBrowse ;
                    OWNERDRAW ;
                    COLOR {||CellArray(5,oBrowse,.t.)}

DCBROWSECOL DATA {||CellArray(6,oBrowse,.f.)} ;
                    HEADER 'Friday' WIDTH 15 PARENT oBrowse ;
                    OWNERDRAW ;
                    COLOR {||CellArray(6,oBrowse,.t.)}

DCBROWSECOL DATA {||CellArray(7,oBrowse,.f.)} ;
                    HEADER 'Saturday' WIDTH 15 PARENT oBrowse ;
                    OWNERDRAW ;
                    COLOR {||CellArray(7,oBrowse,.t.)}

@ 26,0 DCCHECKBOX lOwnerDraw PROMPT 'Use ownerdrawing' ;
       ACTION {||oBrowse:lOwnerDraw := lOwnerDraw,oBrowse:InvalidateRect()}

DCGETOPTIONS RESIZE

DCREAD GUI FIT TITLE 'Calendar sample' OPTIONS GetOptions ;
   EVAL {||oBrowse:arrayElement := nRow, oBrowse:refreshAll()}

RETURN nil

PROC appsys ; RETURN

* ------------

STATIC FUNCTION LoadCalendarArray( aCalendar, dUpdate )

LOCAL nCol, dDate, nLen, i, j, nRow := 1

nCol := 1
dDate := Date()
dDate -= 365

DO WHILE Dow(dDate) > 1
  dDate--
ENDDO

nLen := Len(aCalendar)

BEGIN SEQUENCE
FOR i := 1 TO nLen
  FOR j := 1 TO 7
    IF !Empty(dUpdate) .AND. dDate # dUpdate
      LOOP
    ENDIF
    aCalendar[i,j] := { dDate, {} }
    CALENDAR->(dbSeek(Dtos(dDate)))
    DO WHILE CALENDAR->date == dDate .AND. !CALENDAR->(Eof())
      AAdd( aCalendar[i,j,2], ;
           { CALENDAR->time, ;
             Substr(Sec2Time(CALENDAR->time),1,5), ;
             CALENDAR->duration, ;
             Substr(Sec2Time(CALENDAR->duration),1,5), ;
             CALENDAR->short, ;
             CALENDAR->memo, ;
             CALENDAR->(RecNo()) } )
      CALENDAR->(dbSkip())
    ENDDO
    IF !Empty(dUpdate) .AND. dDate == dUpdate
      BREAK
    ENDIF
    dDate++
    IF dDate == Date()
      nRow := i
    ENDIF
  NEXT
NEXT
END SEQUENCE

RETURN nRow

* ------------

STATIC FUNCTION EditCell( oBrowse )

LOCAL i := oBrowse:arrayElement
LOCAL j := oBrowse:colPos
LOCAL aCalendar := oBrowse:dataSource
LOCAL oBrowseCell, GetList[0], GetOptions
LOCAL aCell := aCalendar[i,j]
LOCAL dDate := aCell[1], bGetSet, oMle
LOCAL aAppts := AClone(aCell[2]), nPointer := 0, lStatus

@ 0,0 DCBROWSE oBrowseCell DATA aAppts SIZE 50,10 FIT ;
      FONT '10.Lucida Console' ;
      NOHSCROLL ;
      ITEMMARKED {||DC_GetRefresh(oMle)} ;
      POINTER nPointer ;
      EDIT xbeBRW_ItemSelected ;
         EXIT {||ASort(aAppts,,,{|a,b|a[1]<b[1]}),oBrowseCell:refreshAll()}

DCBROWSECOL ELEMENT 2 HEADER 'Time' WIDTH 6 PARENT oBrowseCell PICTURE "99:99" ;
   VALID {||ValidateAppt(aAppts[nPointer],1)}
DCBROWSECOL ELEMENT 4 HEADER 'Dur' WIDTH 6 PARENT oBrowseCell PICTURE "99:99" ;
   VALID {||ValidateAppt(aAppts[nPointer],2)}
DCBROWSECOL ELEMENT 5 HEADER 'Subject' WIDTH 50 PARENT oBrowseCell ;
   VALID {||ValidateAppt(aAppts[nPointer],3)}

bGetSet := {|x|IIF(nPointer==0,'',IIF(x==nil,aAppts[nPointer,6],aAppts[nPointer,6]:=x))}
@ 11,0 DCMULTILINE bGetSet SIZE 80,9 ;
       FONT '10.Lucida Console' ;
       OBJECT oMle

@ 21,0 DCPUSHBUTTON CAPTION 'Delete' SIZE 9,1 ;
       ACTION {||aRemove(aAppts,nPointer),oBrowseCell:refreshAll()} ;
       WHEN {||nPointer > 0}

@ DCGUI_ROW, DCGUI_COL + 10 DCPUSHBUTTON CAPTION 'New' SIZE 9,1 ;
       ACTION {||AAdd(aAppts,{0,Space(5),0,Space(5),Space(50),'',0}), ;
                 DC_GetRefresh(GetList), ;
                 oBrowseCell:goBottom(),PostAppEvent(xbeBRW_ItemSelected,,,oBrowseCell)} ;

@ DCGUI_ROW, DCGUI_COL + 10 DCPUSHBUTTON CAPTION 'Ok' SIZE 9,1 ;
       ACTION {||DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList)}

@ DCGUI_ROW, DCGUI_COL + 10 DCPUSHBUTTON CAPTION 'Cancel' SIZE 9,1 ;
       ACTION {||DC_ReadGuiEvent(DCGUI_EXIT_ABORT,GetList)}

DCREAD GUI FIT TITLE 'Appts: ' + Dtoc(dDate) TO lStatus

IF lStatus
  FOR i := 1 TO Len(aAppts)
    IF !Empty(aAppts[i,7])
      CALENDAR->(dbGoTo(aAppts[i,7]))
      CALENDAR->(DC_RecLock())
    ELSE
      CALENDAR->(DC_AddRec())
    ENDIF
    CALENDAR->date := dDate
    CALENDAR->time := aAppts[i,1]
    CALENDAR->duration := aAppts[i,3]
    CALENDAR->short := aAppts[i,5]
    CALENDAR->memo := aAppts[i,6]
    aAppts[i,7] := CALENDAR->(RecNo())
    CALENDAR->(dbRUnlock())
  NEXT
  aCell[2] := aAppts
  LoadCalendarArray( aCalendar, dDate )
  oBrowse:refreshAll()
ENDIF

RETURN nil

* ------------

STATIC FUNCTION ValidateAppt( aAppt, nWhich )

LOCAL lStatus := .f., nTime

IF nWhich == 1 // Time
  nTime := Time2Sec(aAppt[2])
  IF nTime > 24*60*60
  ELSE
    aAppt[1] := nTime
    lStatus := .t.
  ENDIF
ELSEIF nWhich == 2 // Duration
  nTime := Time2Sec(aAppt[4])
  IF nTime > 24*60*60
  ELSE
    aAppt[3] := nTime
    lStatus := .t.
  ENDIF
ELSEIF nWhich == 3 // Subject
  lStatus := !Empty(aAppt[5])
ENDIF

RETURN lStatus

* ------------

STATIC FUNCTION Time2Sec( cTime )

LOCAL nTime

nTime := (Val(Substr(cTime,1,2)) * 3600) + (Val(Substr(cTime,4,2 )) * 60)

RETURN nTime

* ------------

STATIC FUNCTION CellArray( nCol, oBrowse, lColor )

LOCAL aCalendar := oBrowse:dataSource
LOCAL nElement := oBrowse:arrayElement
LOCAL aCell := aCalendar[nElement,nCol]
LOCAL dDate := aCell[1], aData, i, aAppt
LOCAL nCellWidth := 120, nFGColor

IF oBrowse:colCount >= nCol
  nCellWidth := oBrowse:getColumn(nCol):dataArea:currentSize()[1]
ENDIF

/*
  [1] = <ocData>
  [2] = <nCol>
  [3] = <nRow>
  [4] = <nWidth>
  [5] = <nHeight>
  [6] = <font>
  [7] = <selectedFont>
  [8] = <fgColor>
 [ 9] = <bgColor>
 [10] = <nAlign>
*/

IF lColor

  IF Month(dDate) % 2 == 0
    aData := { nil, GraMakeRGBColor({255,255,255}) }
  ELSE
    aData := { nil, GraMakeRGBColor({255,255,255}) }
  ENDIF

ELSE

  IF dDate == Date()
    nFGColor := GRA_CLR_RED
  ELSE
    nFGColor := GRA_CLR_BLACK
  ENDIF

  aData := { { Alltrim(Str(Year(dDate))) + ' ' + CMonth(dDate),10,25,100,30,'10.Arial',,nFGColor }, ;
             { Alltrim(Str(Day(dDate))),nCellWidth-50,40,40,40,'24.Arial Bold',,nFGColor,,XBPALIGN_RIGHT } }

  aAppt := aCell[2]

  FOR i := 1 TO Len(aAppt)
    AAdd(aData,{aAppt[i,2] + ' > ' + aAppt[i,5],10,50+((i-1)*18),,18,'9.Arial Bold',,GRA_CLR_DARKPINK})
  NEXT

ENDIF

RETURN aData

* ----------

STATIC FUNCTION Sec2Time ( nSeconds )

LOCAL nHours, nMinutes

nSeconds := IIF(Valtype(nSeconds)='N',nSeconds,Seconds())

nHours   := nSeconds / (60*60)
nMinutes := nHours - Int(nHours)
nHours   := Int(nHours)
nMinutes := nMinutes * 60
nSeconds := Int( ( nMinutes - Int(nMinutes) ) * 60 )

RETURN StrTran(Str(nHours,2)+':'+Str(nMinutes,2)+':'+Str(nSeconds,2),' ','0')



